{% extends "ajax/ajax_plain.html.twig" %}
{% block ajax_base %}
    {# @var posts \App\Entity\Post[] #}
    {% set today = date() %}
    {% set yesterday = date('-1days') %}
    {% block buttons %}
        <div class="row">
            <div class="cell padded rw-6 left">
                {% if is_granted("ROLE_CROW")%}
                    {% if not locked %}
                        <div x-forum-moderator-action="lock" x-forum-api-endpoint="{{ url('forum_thread_mod_controller', {fid: fid, tid: tid, mod: 'lock'}) }}" class="forum-button"><img alt="" src="{{ asset('build/images/icons/lock.gif') }}" /><span>{{ 'Schließen'|trans({},'global') }}</span></div>
                    {% endif %}
                    {% if locked %}
                        <div x-forum-moderator-action="unlock" x-forum-api-endpoint="{{ url('forum_thread_mod_controller', {fid: fid, tid: tid, mod: 'unlock'}) }}" class="forum-button"><img alt="" src="{{ asset('build/images/icons/mod.png') }}" /><span>{{ 'Öffnen'|trans({},'global') }}</span></div>
                    {% endif %}
                {% endif %}
                {% if is_granted("ROLE_ADMIN") %}
                    {% if not pinned %}
                        <div x-forum-moderator-action="pin" x-forum-api-endpoint="{{ url('forum_thread_mod_controller', {fid: fid, tid: tid, mod: 'pin'}) }}" class="forum-button"><img alt="" src="{{ asset('build/images/icons/mod.png') }}" /><span>{{ 'Anpinnen'|trans({},'global') }}</span></div>
                    {% else %}
                        <div x-forum-moderator-action="unpin" x-forum-api-endpoint="{{ url('forum_thread_mod_controller', {fid: fid, tid: tid, mod: 'unpin'}) }}" class="forum-button"><img alt="" src="{{ asset('build/images/icons/mod.png') }}" /><span>{{ 'Loslösen'|trans({},'global') }}</span></div>
                    {% endif %}
                {% endif %}
            </div>
            <div class="cell padded rw-6 right">
                {% if not locked and not is_granted("ROLE_BANNED") %}
                    <div x-forum-action="answer" class="forum-button"><span>{{ 'Antworten'|trans({},'global') }}</span></div>
                {% else %}
                    <div class="forum-button-disabled"><img alt="" src="{{ asset('build/images/icons/lock.gif') }}" /><span>{{ 'Antworten'|trans({},'global') }}</span></div>
                {% endif %}
            </div>
        </div>
    {% endblock %}
    {% block pagenav %}
        {% if pages > 1 %}
            <div class="row">
                <div class="cell rw-12 padded center">
                    {% if current_page > 1 %}
                        <div class="forum-button" x-forum-action="post-pager" x-to-page="1"><i class="fa fa-fast-backward"></i></div>
                        <div class="forum-button" x-forum-action="post-pager" x-to-page="{{ current_page - 1 }}"><i class="fa fa-backward"></i></div>
                    {% else %}
                        <div class="forum-button-disabled"><i class="fa fa-fast-backward"></i></div>
                        <div class="forum-button-disabled"><i class="fa fa-backward"></i></div>
                    {% endif %}
                    <div class="forum-button">{{ 'Seite %page%/%pages%'|trans({'%page%': current_page, '%pages%': pages},'global') }}</div>
                    {% if current_page < pages %}
                        <div class="forum-button" x-forum-action="post-pager" x-to-page="{{ current_page + 1 }}"><i class="fa fa-forward"></i></div>
                        <div class="forum-button" x-forum-action="post-pager" x-to-page="{{ pages }}"><i class="fa fa-fast-forward"></i></div>
                    {% else %}
                        <div class="forum-button-disabled"><i class="fa fa-forward"></i></div>
                        <div class="forum-button-disabled"><i class="fa fa-fast-forward"></i></div>
                    {% endif %}
                </div>
            </div>
        {% endif %}
    {% endblock %}
    

    {% if announces.admin|length > 0 %}
        <div class="row">
            <div class="cell padded rw-8 ro-2">
                <div class="adminAnnounces announces">
                    <span class="announce">{{'Dieses Thema enthält %count% offizielle Ansage(n) der MyHordes-Administratoren:'|trans({"%count%": announces.admin|length}, 'global')}}</span>
                    <ul>
                        {% for adminannounce in announces.admin %}
                            <li x-ajax-target="#content" x-ajax-href="{{path('forum_jump_view', {pid: adminannounce.id})}}">[{{adminannounce.date|format_datetime('medium', 'none')}}] {{adminannounce.text|striptags|slice(0, 50)}}[...]</li>
                        {% endfor %}
                    </ul>
                </div>
            </div>
        </div>
    {% endif %}

    {% if announces.oracle|length > 0 %}
        <div class="row">
            <div class="row">
                <div class="cell padded rw-8 ro-2">
                    <div class="oracleAnnounces announces">
                        <span class="announce">{{'Dieses Thema enthält %count% Ansage(n) von Community-Vertretern:'|trans({"%count%": announces.oracle|length}, 'global')}}</span>
                        <ul>
                            {% for oracleannounce in announces.oracle %}
                                <li x-ajax-target="#content" x-ajax-href="{{path('forum_jump_view', {pid: oracleannounce.id})}}">[{{oracleannounce.date|format_datetime('medium', 'none')}}] {{oracleannounce.text|striptags|slice(0, 50)}}[...]</li>
                            {% endfor %}
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    {% endif %}
    <div class="forum-posts">
        {% for post in posts %}
            {% if not post.hidden or is_granted("ROLE_CROW") %}
                {% set author_name = (post.owner.username == 'Der Rabe') ? 'Der Rabe'|trans({},'global') : post.owner.username %}
                <div class="forum-post {% if not post.hidden %}{% else %}forum-post-hidden{% endif %} {% if post.new %}forum-post-new{% endif %} {% if markedPost is defined and post.id == markedPost %}forum-post-marked{% endif %}">
                    <div class="forum-post-header {% if post.owner.username == 'Der Rabe' %}header-variant-crow{% elseif post.type == "DEV" %}header-variant-dev{% endif %}">
                        <i>
                            {% if post.date.format('Ymd') == today|date("Ymd") %}
                                {{ 'Heute um'|trans({},'global') }} {{ post.date|format_datetime('none', 'short') }}
                            {% elseif post.date.format('Ymd') == yesterday|date("Ymd") %}
                                {{ 'Gestern um'|trans({},'global') }} {{ post.date|format_datetime('none', 'short') }}
                            {% else %}
                                {{ post.date|format_datetime('medium', 'short') }}
                            {% endif %}
                        </i>
                        {% if (post.owner.avatar) %}
                            {% if app.user.preferSmallAvatars %}
                                {% if post.owner.username == 'Der Rabe' %}
                                    <div class="avatarcrow small"><img alt="" src="{{ path('app_web_avatar', {'uid': post.owner.id, 'name': post.owner.avatar.smallName, 'ext': post.owner.avatar.format}) }}"></div>
                                {% else %}
                                    <div class="avatar small"><img alt="" src="{{ path('app_web_avatar', {'uid': post.owner.id, 'name': post.owner.avatar.smallName, 'ext': post.owner.avatar.format}) }}"></div>
                                {% endif %}
                            {% else %}
                                {% if post.owner.username == 'Der Rabe' %}
                                    <div class="avatarcrow"><img alt="" src="{{ path('app_web_avatar', {'uid': post.owner.id, 'name': post.owner.avatar.filename, 'ext': post.owner.avatar.format}) }}"></div>
                                {% else %}
                                    <div class="avatar"><img alt="" src="{{ path('app_web_avatar', {'uid': post.owner.id, 'name': post.owner.avatar.filename, 'ext': post.owner.avatar.format}) }}"></div>
                                {% endif %}
                            {% endif %}
                        {% else %}
                            <div class="avatar small"><img alt="" src="{{ asset('build/images/forum/empty_avatar.gif') }}"></div>
                        {% endif %}
                        <b>{{ author_name }}</b>
                        {% if post.note is not null %}<div class="right post-note">{{ post.note|raw }}</div>{% endif %}
                    </div>
                    <div class="forum-post-content" x-post-content-id="{{ post.id }}" x-post-content-author="{{ author_name }}">
                        {{ post.translate ? (post.text|trans({},'game')|raw) : (post.text|raw) }}
                    </div>
                    <div class="forum-post-footer right">
                        {% if is_granted("ROLE_CROW") %}
                            <label class="mod-submenu" for="mod-submenu-toggle-{{ post.id }}">
                                <input type="checkbox" name="mod-submenu-toggle-{{ post.id }}" id="mod-submenu-toggle-{{ post.id }}" />
                                <ul class="mod-submenu-links">
                                    {% if not post.hidden %}
                                        <li><a class="action-button" id="delete_post" x-forum-moderator-action="delete-post" x-post-id={{ post.id }} x-to-page={{ current_page }}>{{ 'Löschen'|trans({},'global') }}</a></li>
                                    {% endif %}
                                </ul>
                            </label>
                        {% endif %}
                        [ <a class="action-button" id="link_post" x-forum-action="link-post" x-post-id={{ post.id }}>{{ 'Link'|trans({},'global') }}</a> ]
                        {% if not locked %}
                            [ <a class="action-button" id="quote_post" x-forum-action="quote-post" x-post-id={{ post.id }} >{{ 'Zitieren'|trans({},'global') }}</a> ]
                        {% endif %}
                        [ <a class="action-button" id="report_post" x-forum-action="report-post" x-post-id={{ post.id }} x-to-page={{ current_page }}>{{ 'Melden'|trans({},'global') }}</a> ]
                        <div class="small hidden" id="link-post-{{ post.id }}">
                            <div class="float-left"><i>{{ 'Permanenter Link zu diesem Post:'|trans({},'global') }}</i></div>
                            <div class="float-right">{{ url('forum_jump_view', {pid: post.id}) }}</div>
                        </div>
                    </div>
                </div>
            {% endif %}
        {% endfor %}
    </div>
    {{ block('buttons') }}
    {{ block('pagenav') }}
{% endblock %}
{% block js %}
    {{ parent() }}
    {% for label, messages in app.flashes %}
        {% for message in messages %}
            <x-message x-label="{{ label }}">{{ message|raw }}</x-message>
        {% endfor %}
    {% endfor %}
    <script>
        const loadPage = function(page) {
            $.ajax.no_history().load( document.getElementById('forum-content'), '{{ path('forum_viewer_controller', {fid: fid, tid: tid}) }}', false, {page: page } );
        };
        const reloadPage = function() { loadPage( {{ current_page }} ); };

        $.html.addEventListenerAll('[x-forum-action="link-post"]', 'click', function(e,elem) {
            let link = document.getElementById('link-post-' + elem.getAttribute('x-post-id'));
            if (link.classList.contains('hidden')) link.classList.remove('hidden');
            else link.classList.add('hidden');
        });

        $.html.addEventListenerAll('[x-forum-action="report-post"]', 'click', function(e,elem) {
            $.ajax.easySend( '{{ url('forum_report_post_controller', { 'fid': fid, 'tid': tid}) }}', {postId: parseInt( elem.getAttribute('x-post-id')), page: parseInt( elem.getAttribute('x-to-page')) }, reloadPage );
        });

        $.html.addEventListenerAll('[x-forum-action="quote-post"]', 'click', function(e,elem) {
            let editor = document.getElementById('forum-editor');

            let fun_quote = function() {
                let content = document.querySelector('[x-post-content-id="' + elem.getAttribute('x-post-id') + '"]');
                let author = content.getAttribute('x-post-content-author');
                let textEditor = document.getElementById("forum-editor-text");
                textEditor.value = (author ? ('[quote=' + author + ']') : '[quote]') + $.html.twinoParser.parseFrom( content.innerHTML, true ) + '[/quote]' + "\n";
                textEditor.dispatchEvent(new Event('input', {bubbles: true,cancelable: true}));
                textEditor.focus();
            };

            if (editor && editor.innerHTML === "") {
                $.ajax.no_history().load( document.getElementById('forum-editor'), '{{ path('forum_post_editor_controller', {fid: fid, tid: tid}) }}', false, {}, fun_quote )
            } else fun_quote();
        });

        {% if is_granted("ROLE_CROW") %}
            $.html.addEventListenerAll( '[x-forum-moderator-action="delete-post"]', 'click', function(e,elem) {
                let reason = prompt('{{ 'Grund'|trans({},'admin')|e('js') }}', '');
                if (reason !== null)
                    $.ajax.easySend( '{{ url('forum_thread_mod_controller', { 'fid': fid, 'tid': tid, mod: 'delete'}) }}', {reason: reason, postId: parseInt( elem.getAttribute('x-post-id')) }, reloadPage );
            } );
            $.html.addEventListenerAll( '[x-forum-moderator-action][x-forum-api-endpoint]', 'click', function(e,elem) {
                $.ajax.easySend( elem.getAttribute('x-forum-api-endpoint'), {}, reloadPage );
            } );
        {% endif %}

        $.html.addEventListenerAll( '.announces li', 'click', function(e,elem) {
            $.ajax.no_history().load( document.getElementById('forum-content'), '{{ path('forum_viewer_controller', {fid: fid, tid: tid}) }}', false, {page:1, firstpost: elem.getAttribute('x-post-id') } );
        } );

        $.html.addEventListenerAll( '[x-forum-action="answer"]', 'click', function(e,elem) {
            $.html.forEach('[x-forum-action="answer"]', e => e.remove());
            $.ajax.no_history().load( document.getElementById('forum-editor'), '{{ path('forum_post_editor_controller', {fid: fid, tid: tid}) }}', false, {}, function() {
                document.getElementById("forum-editor").scrollIntoView();
                document.getElementById("forum-editor-text").focus();
            } );

        } );

        $.html.addEventListenerAll( '[x-forum-action="post-pager"][x-to-page]', 'click', function(e,elem) {
            let editor = document.getElementById('forum-editor');
            {% if editor is defined %}
                {let c; while ((c = editor.firstChild)) editor.removeChild(c);}
            {% endif %}
            $.ajax.no_history().load( document.getElementById('forum-content'), '{{ path('forum_viewer_controller', {fid: fid, tid: tid}) }}', false, {page: parseInt( elem.getAttribute('x-to-page') ) },
                () => document.querySelector('.forum-post:last-child').scrollIntoView()
            );
        } );

        {% if pages == current_page %}
            $.html.forEach( '[x-thread-id="{{ tid }}"]', e => e.classList.remove('forum-thread-unread') );
        {% endif %}

        {% if markedPost is defined and markedPost > 0 %}
            document.querySelector('[x-post-content-id="{{markedPost}}"]').parentElement.scrollIntoView();
        {% endif %}
    </script>
{% endblock %}